
ams_begin EQU .


	MAC LOP
		dc.b (({1} & $7F) | $80)
		dc.b $00
	ENDM

	MAC STP
		dc.b ((({1} << 1) & $7E) | $01)
		dc.b $01
	ENDM

	MAC STPX
		dc.b ((({1} << 1) & $7E) | $01)
		dc.b {2}
	ENDM

	MAC SPC
		dc.b (((({2} & $0F) << 2) | (({1} >> 8) & $03)) << 1)
		dc.b ({1} & $FF)
	ENDM



	; note, instrument, dauer
	MAC T_SET
		dc.b ({1} & $7F),(({2} & $0F) << 4) | ({3} & $0F)
	ENDM
	MAC T_SETX
		dc.b (({1} & $7F) | $80),(({4} & $03) << 4) | ({5} & $03) << 6) | ({6} & $0F),(({2} & $0F) << 4) | ({3} & $0F)
	ENDM
	MAC T_HLT
		dc.b $FF
	ENDM



	; track, transpose,repeat
	MAC S_TRK 
		dc.b ({2} & $0F) | (({3} & $0F) << 4),{1}
	ENDM
	
	MAC S_HLT
		dc.b $0F,$01
	ENDM

	MAC S_HLTX
		dc.b $0F,{1}
	ENDM


;------------------------------------------------------------------------------
; zustnde fr song
;------------------------------------------------------------------------------
ams_groovecounter
	dc.b $00
ams_groovebox_index
	dc.b $00

ams_addr_lo
	dc.b <ams_seqdata1,<ams_seqdata2,<ams_seqdata3
ams_addr_hi
	dc.b >ams_seqdata1,>ams_seqdata2,>ams_seqdata3


ams_seqpos			
	dc.b $00,$00,$00

ams_trackrepeat		
	dc.b $01,$01,$01



;------------------------------------------------------------------------------
; zustnde fr tracks
;------------------------------------------------------------------------------
amt_counter
	dc.b $00,$00,$00
amt_addr_lo
	dc.b $00,$00,$00
amt_addr_hi
	dc.b $00,$00,$00
amt_trackpos
	dc.b $00,$00,$00
amt_transpose
	dc.b $00,$00,$00
amt_amplify
	dc.b $09,$09,$09
amt_vibrato
	dc.b $00,$00,$00
	



;------------------------------------------------------------------------------
; zustnde fr voices
;------------------------------------------------------------------------------
amv_note			
	dc.b $00,$00,$00
amv_volume			
	dc.b $00,$00,$00

amv_duration 		
	dc.b $00,$00,$00
amv_ctrl			
	dc.b $00,$00,$00	
amv_instrument		
	dc.b $00,$00,$00

	
amv_codepos			
	dc.b $00,$00,$00
amv_volcounter		
	dc.b $00,$00,$00
amv_freq_lo			
	dc.b $00,$00,$00
amv_freq_hi			
	dc.b $00,$00,$00	
	
amv_vibpos
	dc.b $00,$02,$02
amv_vibspeed
	dc.b $08,$08,$08
amv_vibdepth
	dc.b $03,$03,$03

amv_envpos
	dc.b $00,$00,$00
amv_envlo
	dc.b $00,$00,$00
amv_envhi
	dc.b $00,$00,$00
amv_envreset
	dc.b $00,$00,$00	



ammix_freq_lo
	dc.b $00,$00
ammix_freq_hi
	dc.b $00,$00
ammix_ctrl
	dc.b $00,$00
ammix_volume
	dc.b $00,$00

	


ami_zpbase		EQU $FE
;ami_volthres 	EQU $04	; schwellwert fr lautstrken differenz. der leisere kanal wird ausgeschaltet
;ami_plexthres 	EQU $02	; multiplexen zwischen kanal 2 und 3, schwellwert fr lautstrken differenz. der leisere kanal wird ausgeschaltet

ami_volthres 	EQU $04	; schwellwert fr lautstrken differenz. der leisere kanal wird ausgeschaltet
ami_plexthres 	EQU $01	; multiplexen zwischen kanal 2 und 3, schwellwert fr lautstrken differenz. der leisere kanal wird ausgeschaltet


am_vib
	dc.b $00,$00,$00,$00,$00,$00,$00,$00
	dc.b $01,$01,$01,$01,$01,$01,$01,$01
	dc.b $02,$02,$02,$02,$02,$02,$02,$02
	dc.b $03,$03,$03,$03,$03,$03,$03,$03
	dc.b $03,$03,$03,$03,$03,$03,$03,$03
	dc.b $02,$02,$02,$02,$02,$02,$02,$02
	dc.b $01,$01,$01,$01,$01,$01,$01,$01
	dc.b $00,$00,$00,$00,$00,$00,$00,$00


am_vibsteps
	dc.b $01,$02,$04,$08













;------------------------------------------------------------------------------
;
; am_out
;
; zweck		: TED-register setzen
; rckgabe	: -
; zerstrt	: a
;
; eingabe:	-
;
;------------------------------------------------------------------------------
am_out SUBROUTINE



	;-------------------------------------
	; mixer vorbereiten
	;-------------------------------------
	LDX #$01
.1	LDA amv_freq_lo,x
	STA ammix_freq_lo,x
	LDA amv_freq_hi,x
	STA ammix_freq_hi,x
	LDA amv_ctrl,x
	STA ammix_ctrl,x
	LDA amv_volume,x
	STA ammix_volume,x
	DEX
	BPL .1
	;-------------------------------------







	;-------------------------------------
	; multiplexen, falls mglich
	;-------------------------------------
;	LDA amv_ctrl+2
;	AND #$02
;	BEQ .not_to_channel1
	LDA amv_volume
	BEQ .multiplex_to_channel1

.not_to_channel1
	; auf kanal 2 wird gemultiplext, wenn der schwellenwert der lautstrkendifferenz berschritten ist	
	LDA amv_volume+2
	SEC
	SBC #ami_plexthres
	BCS .nounderflow
	LDA #$00
.nounderflow
	CMP amv_volume+1
	BCC .dontmultiplex	
		
	LDY #$01
	JMP .out
	
.dontmultiplex
	JMP .skipmultiplex
	
	
	; auf kanal 1 wird nur gemultiplext, wenn der kein gerusch von sich gibt	
.multiplex_to_channel1	
	LDY #$00
	; multiplex ausfhren
.out
	LDX #$02
	LDA amv_freq_lo,x
	STA ammix_freq_lo,y
	LDA amv_freq_hi,x
	STA ammix_freq_hi,y
	LDA amv_ctrl,x
	STA ammix_ctrl,y
	LDA amv_volume,x
	STA ammix_volume,y
.skipmultiplex	
	;-------------------------------------







	;-------------------------------------
	; ausgabe auf TED
	;-------------------------------------
	LDA ammix_freq_lo
	STA $FF0E
	LDA $FF12
	AND #$FC
	STA .ff12

	LDA ammix_freq_hi
	AND #$03
.ff12 = .+1
	ORA #$00	
	STA $FF12
	
	LDA ammix_freq_lo+1
	STA $FF0F
	LDA ammix_freq_hi+1
	STA $FF10
	

	;---------------------------------------
	; lautstrken-auswertung
	;---------------------------------------
	SEC
	LDA ammix_volume
	SBC ammix_volume+1
	BCS .vol1lauter
	
	EOR #$FF
	ADC #$01
	CMP #ami_volthres
	BCC .standard	

	LDA #$00
	STA ammix_ctrl	
	LDA ammix_volume+1
	JMP .usevol1

	
.vol1lauter	
	CMP #ami_volthres
	BCC .standard	
	
	LDA #$00
	STA ammix_ctrl+1
	LDA ammix_volume
	JMP .usevol1


.standard
	LDA ammix_volume
	CMP ammix_volume+1
	BCS .usevol1
	LDA ammix_volume+1
	
.usevol1
	STA ami_zpbase
	;---------------------------------------


	;---------------------------------------
	; anaus/rauschen
	;---------------------------------------

	LDA ammix_ctrl+1
	AND #$30
	ASL
	ORA ami_zpbase
	STA ami_zpbase

	LDA ammix_ctrl
	AND #$10
	ORA ami_zpbase

	;---------------------------------------
	STA $FF11
	RTS
;------------------------------------------------------------------------------







;------------------------------------------------------------------------------
;
; am_tracktick
;
; zweck		: track ausfhren
; rckgabe	: -
; zerstrt	: a,y
;
; eingabe:	x : stimme
;
;------------------------------------------------------------------------------

am_tracktick SUBROUTINE

	; dauer der note abwarten
	LDA amt_counter,X
	BNE .dovoice

	; trackadresse holen
	LDA amt_addr_lo,X
	STA ami_zpbase
	LDA amt_addr_hi,X
	STA ami_zpbase+1
	
.again	
	LDY amt_trackpos,X
	LDA (ami_zpbase),Y

	; wenn $FF -> track zuende
	CMP #$FF
	BNE .newtrackinfo

	LDA #$00
	STA amt_trackpos,X
	JMP .again	
	
	
.newtrackinfo	

	; note merken	
	PHA
	
	BPL .noeffects
	
	INY
	LDA (ami_zpbase),Y
	PHA
	AND #$0F
	STA amt_amplify,X
	PLA
	LSR
	LSR
	LSR
	LSR
	PHA
	AND #$03
	STA amv_vibdepth,X
	PLA
	LSR
	LSR
	STY .savey
	TAY
	LDA am_vibsteps,Y
	STA amv_vibspeed,X
.savey = .+1
	LDY #$00
	
.noeffects	
	
	; instrument und dauer holen	
	INY
	LDA (ami_zpbase),Y
	PHA
	AND #$0F
	STA amt_counter,X

	; zeiger speichern
	INY
	TYA
	STA amt_trackpos,X
	
	
	; instrument holen
	PLA
	LSR
	LSR
	LSR
	LSR
	TAY
	PLA
	AND #$7F
	CPY #$00
	BEQ .dovoice
	CLC 
	ADC amt_transpose,X
	JSR am_setvoice

.dovoice
	DEC amt_counter,X
	RTS




;------------------------------------------------------------------------------
;
; am_songtick
;
; zweck		: track ausfhren
; rckgabe	: -
; zerstrt	: a,x,y
;
; eingabe:	-
;
;------------------------------------------------------------------------------
am_songtick SUBROUTINE

	DEC ams_groovecounter
	BPL .dovoices

	; grooven bitte
	LDA ams_groovebox_index
	CLC
	ADC #$01
	AND #$01
	STA ams_groovebox_index
	TAX
	LDA ams_groovebox,X
	STA ams_groovecounter

	LDX #$02
	
.doseq
	DEC ams_trackrepeat,X
	BNE .continue

	; sequenzen-adresse holen
	LDA ams_addr_lo,X
	STA ami_zpbase
	LDA ams_addr_hi,X
	STA ami_zpbase+1

.again
	LDY ams_seqpos,X
	LDA (ami_zpbase),Y

	CMP #$0F
	BNE .nostop
	
	INY
	LDA ams_seqpos,X
	SEC
	SBC (ami_zpbase),Y
	SEC
	SBC (ami_zpbase),Y
	STA ams_seqpos,X
	JMP .again
	
.nostop	

	; transpose und repeat verarbeiten
	PHA
	AND #$0F
	STA amt_transpose,X
	PLA
	AND #$F0
	

	ASL
	STA ams_trackrepeat,X

	; tracknummer holen
	INY
	LDA (ami_zpbase),Y
	PHA
	
	; position zurckschreiben
	INY
	TYA
	STA ams_seqpos,X
	
	; track nachschlagen und schreiben
	PLA
	TAY
	LDA ams_tracktab_lo,Y
	STA amt_addr_lo,X
	LDA ams_tracktab_hi,Y
	STA amt_addr_hi,X
	LDA #$00
	STA amt_counter,X
	STA amt_trackpos,X

	
.continue	
	DEX
	BPL .doseq




	
.dovoices
	LDX #$02
.voiceloop
	LDA ams_groovecounter
	BNE .skiptracktick
	JSR am_tracktick
.skiptracktick	
	JSR am_voicetick
	DEX
	BPL .voiceloop

;	JSR am_out

	RTS





;------------------------------------------------------------------------------
;
; am_setvoice
;
; zweck		: instrument setzen 
; rckgabe	: -
; zerstrt	: a
;
; eingabe:
; 			a : note
; 			x : stimme
; 			y : instrument
;
;------------------------------------------------------------------------------
am_setvoice SUBROUTINE

	CPY #$0F
	BEQ .exit

	; note setzen
	STA amv_note,X

	; dauer
	LDA ami_duration,Y
	STA amv_duration,X
	
	; envelope holen
	STY .savey
	LDA ami_ctrl,Y
	AND #$07
	TAY
	LDA am_env_lo,Y
	STA amv_envlo,X
	LDA am_env_hi,Y
	STA amv_envhi,X

	; oneshot oder looping envelope
	LDA #$1f
	STA amv_envreset,X

.savey = .+1	
	LDY #$00
	
	LDA ami_ctrl,Y
	AND #$08
	BEQ .envloop_end
	
	
	LDA #$00
	STA amv_envreset,X
.envloop_end	
	; instrument-index
	TYA
	STA amv_instrument,X
	
	; codezeiger und lautstrke-zhler auf null
	LDA #$00
	STA amv_codepos,X
	STA amv_volcounter,X
	STA amv_envpos,X
.exit
	RTS	
;------------------------------------------------------------------------------













	
	





;------------------------------------------------------------------------------
;
; am_voicetick
;
; zweck		: ton berechnen
; rckgabe	: -
; zerstrt	: a,y
;
; eingabe:
; 			x : stimme
;
;------------------------------------------------------------------------------
am_voicetick SUBROUTINE

	; dauer des instruments verarbeiten
	LDA amv_duration,X
	BNE .isactive

	; is aus? dann schalten wir die ctrl-werte auch mal lieber ab (muss ich hinterher weniger kontrollieren...)
	LDA #$00
	STA amv_ctrl,X
	STA amv_volume,X
	RTS
	
.isactive	
	DEC amv_duration,X
	LDA amv_duration,X
	CMP #$FE
	BNE .notendless

	LDA #$FF
	STA amv_duration,X
		
	
.notendless	


	; quelladresse (zp) fr steuerkommandos ermitteln	
	LDY amv_instrument,X
	LDA ami_code_lo,Y
	STA ami_zpbase
	LDA ami_code_hi,Y
	STA ami_zpbase+1

	; steuerkommandos auslesen und interpretieren
.again
	LDA amv_codepos,X
	ASL
	TAY
.code
	LDA (ami_zpbase),Y
	BPL .dowrite
	
	; sprung ausfhren
	AND #$7F
	STA amv_codepos,X
	JMP .again
	
.dowrite

	LSR
	BCS .dotranspose
	
.dopitchctrl

	; mit den steuercodes fange ich erst spter etwas an...	
	PHA
	ASL
	ASL
	STA amv_ctrl,X				
	PLA

	; pitch auslesen
	AND #$03
	STA amv_freq_hi,X
	INY
	LDA (ami_zpbase),Y
	STA amv_freq_lo,X

	; weiter im text...
	JMP .freqwritten

	
	
.dotranspose

	PHA
		
;	INC amv_vibpos,X
;	LDA amv_vibpos,X
;	AND #$0F
;	TAY
;	LDA am_vib,Y
;	STA .vib+1

	LDA amv_vibpos,X
	CLC
	ADC amv_vibspeed,X
	AND #$3f
	STA amv_vibpos,X
	TAY

	LDA am_vib,Y
	SEC
	SBC amv_vibdepth,X
	BCS .vibpositive
	LDA #$00
.vibpositive
	STA .vib

	
	LDA amv_ctrl,X
	ORA #$10
	STA amv_ctrl,X
	
	PLA
	CLC
	ADC amv_note,X
	ASL
	ASL

	CLC
.vib = .+1
	ADC #$00
	
	TAY
	LDA am_freq_lo,Y
;.vib	
;	ADC #$00
	STA amv_freq_lo,X
;	LDA #$00
;	ADC am_freq_hi,Y
	LDA am_freq_hi,Y
	STA amv_freq_hi,X
	
	
	; lautstrke ermitteln
.freqwritten	

	; envelope fertig!? tschss!
	LDA amv_envpos,X
	CMP #$20
	BCC .envposok
	
	LDA amv_envreset,X
	STA amv_envpos,X
.envposok	

	; noch warten?!
	LDA amv_volcounter,X
	BNE .volwait

	; lautstrke holen
	LDA amv_envlo,X
	STA ami_zpbase
	LDA amv_envhi,X
	STA ami_zpbase+1

	; schreiben
	LDY amv_envpos,X
	LDA (ami_zpbase),Y

	CLC
	ADC amt_amplify,X
	SEC
	SBC #$09
	BCS .volpositive
	LDA #$00

.volpositive	
	STA amv_volume,X
	BNE .notsilent
	LDA #$00
	STA amv_ctrl,X
.notsilent
	; einen schritt vorwaerts...
	INC amv_envpos,X

	; wartezhler zurcksetzen
	LDY amv_instrument,X
	LDA ami_decay,Y
	STA amv_volcounter,X

	JMP .exit	

.volwait
	DEC amv_volcounter,X	


.exit
	; codezeiger speichern
	INC amv_codepos,X
	RTS
;------------------------------------------------------------------------------


;------------------------------------------------------------------------------
; frequenztabelle
;------------------------------------------------------------------------------
am_freq_lo
	dc.b $00,$0F,$1D,$2C,$3A,$48,$55,$63,$70,$7D,$8A,$97,$A3,$B0,$BC,$C8
	dc.b $D3,$DF,$EB,$F6,$01,$0C,$17,$22,$2C,$37,$41,$4B,$55,$5F,$68,$72
	dc.b $7B,$84,$8D,$96,$9F,$A8,$B1,$B9,$C1,$CA,$D2,$DA,$E2,$E9,$F1,$F9
	dc.b $00,$07,$0F,$16,$1D,$24,$2B,$31,$38,$3F,$45,$4B,$52,$58,$5E,$64
	dc.b $6A,$70,$75,$7B,$81,$86,$8B,$91,$96,$9B,$A0,$A5,$AA,$AF,$B4,$B9
	dc.b $BE,$C2,$C7,$CB,$D0,$D4,$D8,$DD,$E1,$E5,$E9,$ED,$F1,$F5,$F9,$FC
	dc.b $00,$04,$07,$0B,$0E,$12,$15,$19,$1C,$1F,$22,$26,$29,$2C,$2F,$32
	dc.b $35,$38,$3B,$3D,$40,$43,$46,$48,$4B,$4E,$50,$53,$55,$58,$5A,$5C
	dc.b $5F,$61,$63,$66,$68,$6A,$6C,$6E,$70,$72,$74,$76,$78,$7A,$7C,$7E
	dc.b $80,$82,$84,$85,$87,$89,$8B,$8C,$8E,$90,$91,$93,$94,$96,$97,$99
	dc.b $9A,$9C,$9D,$9F,$A0,$A2,$A3,$A4,$A6,$A7,$A8,$A9,$AB,$AC,$AD,$AE
	dc.b $AF,$B1,$B2,$B3,$B4,$B5,$B6,$B7,$B8,$B9,$BA,$BB,$BC,$BD,$BE,$BF
	dc.b $C0,$C1,$C2,$C3,$C4,$C4,$C5,$C6,$C7,$C8,$C9,$C9,$CA,$CB,$CC,$CC
	dc.b $CD,$CE,$CF,$CF,$D0,$D1,$D1,$D2,$D3,$D3,$D4,$D5,$D5,$D6,$D7,$D7
	dc.b $D8,$D8,$D9,$D9,$DA,$DB,$DB,$DC,$DC,$DD,$DD,$DE,$DE,$DF,$DF,$E0
	dc.b $E0,$E0,$E1,$E1,$E2,$E2,$E3,$E3,$E3,$E4,$E4,$E5,$E5,$E5,$E6,$E6


am_freq_hi
	dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dc.b $00,$00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
	dc.b $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
	dc.b $02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02
	dc.b $02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02
	dc.b $02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02
	dc.b $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03
	dc.b $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03
	dc.b $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03
	dc.b $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03
	dc.b $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03
	dc.b $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03
	dc.b $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03
	dc.b $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03
	dc.b $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03
	dc.b $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03
;------------------------------------------------------------------------------


	
	include "hazisan.asm"

	ECHO "music size: ",[.-ams_begin]
	